<?php
/* traitement d'une image */
function ps_renderPic($object,$effect,$width,$height)
{
	$return="";
	if ($effect->opacity==0||$effect->show)	return $return;
	/* proportions */
	if (PS_USEXL)	$object->data=ps_getxlname($object->data);
	$size=getimagesize($object->data);
	if (!$size[0]||!$size[1])	return $return;			// si taille 0

	/* sans rotation */
	$effect->width*=$width;
	if ($effect->height===false)		$effect->height=$effect->width*($size[1]/$size[0]);
	else								$effect->height*=$height;
	/* avec */
	if ($effect->rotate)
	{
		$angle=$effect->rotate*360;
		$rotation=" -background none -rotate ".$angle." +repage";
		$angle=abs($angle);
		if ($angle>=180)	$angle-=180;
		if ($angle<=90)
		{
			$angle=deg2rad($angle);
			$clipx2=$size[0]*cos($angle)+$size[1]*sin($angle)-1;
			$clipy2=$size[0]*sin($angle)+$size[1]*cos($angle)-1;

			$nw=$effect->width*cos($angle)+$effect->height*sin($angle);
			$nh=$effect->width*sin($angle)+$effect->height*cos($angle);
			$diffx=$effect->width-$nw;
			$diffy=$effect->height-$nh;
		}
		else
		{
			$angle-=90;
			$angle=deg2rad($angle);
			$clipy2=$size[0]*cos($angle)+$size[1]*sin($angle)-1;
			$clipx2=$size[0]*sin($angle)+$size[1]*cos($angle)-1;

			$nh=$effect->width*cos($angle)+$effect->height*sin($angle);
			$nw=$effect->width*sin($angle)+$effect->height*cos($angle);
			$diffx=$effect->width-$nw;
			$diffy=$effect->height-$nh;
		}

		// position haute du clip dans l'affichage
		$clipleft=$effect->x*$width+$diffx/2;
		$cliptop=$effect->y*$height+$diffy/2;
		// position basse du clip dans l'affichage
		$effect->width=$nw;
		$effect->height=$nh;
		$clipright=$effect->width+$clipleft-1;
		$clipbottom=$effect->height+$cliptop-1;
		// position haute du clip dans l'image
		$clipx=0;
		$clipy=0;
	}
	else
	{
		$rotation="";
		/* variables de travail */
		// position haute du clip dans l'affichage
		$clipleft=$effect->x*$width;
		$cliptop=$effect->y*$height;
		// position basse du clip dans l'affichage
		$clipright=$effect->width+$clipleft-1;
		$clipbottom=$effect->height+$cliptop-1;
		// postion haute du clip dans l'image
		$clipx=0;
		$clipy=0;
		// position basse du clip dans l'image
		$clipx2=$size[0]-1;
		$clipy2=$size[1]-1;
	}
	/* correction zoom */
	if ($effect->zoom!=1)
	{
		$clipleft-=($effect->width*($effect->zoom-1))/2;
		$cliptop-=($effect->height*($effect->zoom-1))/2;
		$clipright+=($effect->width*($effect->zoom-1))/2;
		$clipbottom+=($effect->height*($effect->zoom-1))/2;
	}
	/* boucle sur les parents */
	$uid=$object->parent;
	while ($uid)
	{
		$parent=_O($uid);
		$peffect=$parent->actualeffect;

		/* ------------------Opacity and effects */
		$effect->opacity*=$peffect->opacity;
		$effect->blur+=$peffect->blur;
		$effect->sepia+=$peffect->sepia;
		$effect->bw+=$peffect->bw;
		$effect->saturate*=$peffect->saturate;
		$effect->bright*=$peffect->bright;
		$effect->flipx+=$peffect->flipx;
		$effect->flipy+=$peffect->flipy;
		$effect->mblur|=$peffect->mblur;
		/* ----------------- Rotation */
		//$effect->rotate+=$peffect->rotate;

		/* --------------correction clipping si parent avec width
		/*clipping haut gauche si taille */
		if ($peffect->width)
		{
			if ($clipleft<0)
			{
				if ($effect->flipx&1)		$clipx2-=Clip($clipleft,$clipright-$clipleft+1,$clipx-$clipx2+1);
				else						$clipx-=Clip($clipleft,$clipright-$clipleft+1,$clipx2-$clipx+1);
				$clipleft=0;
			}
			if ($cliptop<0)
			{
				if ($effect->flipy&1)		$clipy2-=Clip($cliptop,$clipbottom-$cliptop+1,$clipy-$clipy2+1);
				else						$clipy-=Clip($cliptop,$clipbottom-$cliptop+1,$clipy2-$clipy+1);
				$cliptop=0;
			}
			/* clipping bas droite */
			if ($clipright>$peffect->width)
			{
				$clipx2+=Clip($peffect->width-$clipright,$clipright-$clipleft+1,$clipx2-$clipx+1);
				$clipright=$peffect->width;
			}
			if ($clipbottom>$peffect->height)
			{
				$clipy2+=Clip($peffect->height-$clipbottom,$clipbottom-$cliptop+1,$clipy2-$clipy+1);
				$clipbottom=$peffect->height;
			}
		}
		/* --------------------zoom */
		if ($peffect->zoom!=1)
		{
			if ($peffect->width) // si taille parent origine 50%
			{
				$clipleft=Zoom($clipleft,$peffect->width/2-1,$peffect->zoom);
				$clipright=Zoom($clipright,$peffect->width/2-1,$peffect->zoom);
				$cliptop=Zoom($cliptop,$peffect->height/2-1,$peffect->zoom);
				$clipbottom=Zoom($clipbottom,$peffect->height/2-1,$peffect->zoom);
			}
			else				// pas de taille parent origine 0
			{
				$clipleft*=$peffect->zoom;
				$clipright*=$peffect->zoom;
				$cliptop*=$peffect->zoom;
				$clipbottom*=$peffect->zoom;
			}
		}
		/*-------------------------déplacement */
		$clipleft+=$peffect->x;
		$clipright+=$peffect->x;
		$cliptop+=$peffect->y;
		$clipbottom+=$peffect->y;
		/* rotation */
		/*if ($peffect->rotate)
		{
			$distance=distanceXY($clipleft , $clipright , $cliptop , $clipbottom , $peffect->x , $peffect->y);
			$clipleft-=rotateX($peffect->rotate,$distance);
			$clipright-=rotateX($peffect->rotate,$distance);
			$cliptop+=rotateY($peffect->rotate,$distance);
			$clipbottom+=rotateY($peffect->rotate,$distance);
		}*/
		/* motion blur */
		$mblur="";
		/*if ($_SESSION['motionblur'])
		{
			if ($effect->mblur)
			{
				if (!isset($_SESSION['mblur'][$effect->parent][0]) || $_SESSION['mblur'][$effect->parent][0]===false)
				{
					$_SESSION['mblur'][$effect->parent][0]=$clipleft;
					$_SESSION['mblur'][$effect->parent][1]=$cliptop;
				}
				else
				{
					//$mblur=motion_blur($_SESSION['mblur'][$effect->parent][0],$clipleft,$_SESSION['mblur'][$effect->parent][1],$cliptop);
					$_SESSION['mblur'][$effect->parent][0]=$clipleft;
					$_SESSION['mblur'][$effect->parent][1]=$cliptop;
				}
			}
			else		// pas de effect->mblur
			{
				$_SESSION['mblur'][$effect->parent][0]=false;
				$_SESSION['mblur'][$effect->parent][1]=false;
			}
		}*/
		/* boucle */
		$uid=$parent->parent;
	}
	// on clippe le tour de l'écran
		if ($clipleft<0)
		{
			if ($effect->flipx&1)		$clipx2-=Clip($clipleft,$clipright-$clipleft+1,$clipx-$clipx2+1);
			else						$clipx-=Clip($clipleft,$clipright-$clipleft+1,$clipx2-$clipx+1);
			$clipleft=0;
		}
		if ($cliptop<0)
		{
			if ($effect->flipy&1)		$clipy2-=Clip($cliptop,$clipbottom-$cliptop+1,$clipy-$clipy2+1);
			else $clipy-=Clip($cliptop,$clipbottom-$cliptop+1,$clipy2-$clipy+1);
			$cliptop=0;
		}
		//clipping droit bas
		if ($clipright>$width)
		{
			if ($effect->flipx&1)		$clipx+=Clip($width-$clipright,$clipright-$clipleft+1,$clipx-$clipx2+1);
			else						$clipx2+=Clip($width-$clipright,$clipright-$clipleft+1,$clipx2-$clipx+1);
			$clipright=$width;
		}
		if ($clipbottom>$height)	
		{
			if ($effect->flipy&1)		$clipy+=Clip($height-$clipbottom,$clipbottom-$cliptop+1,$clipy-$clipy2+1);
			else						$clipy2+=Clip($height-$clipbottom,$clipbottom-$cliptop+1,$clipy2-$clipy+1);
			$clipbottom=$height;
		}

	/* si image nulle return */
	if (($clipright-$clipleft)<0 || ($clipbottom-$cliptop)<0)	return "";
	/* size */
	$size=intval($clipright-$clipleft+1)."x".intval($clipbottom-$cliptop+1)."\!";
	$crop=intval($clipx2-$clipx+1)."x".intval($clipy2-$clipy+1)."+".intval($clipx)."+".intval($clipy);
	/* mise à zéro des effets */
	$ef_trans="";
	$ef_blur="";
	$ef_matrix="";
	$ef_saturate="";
	$ef_bright="";
	$ef_flipflop="";

	if ($effect->opacity!=1)	$ef_trans=" -alpha on -channel a -evaluate multiply ".$effect->opacity." +channel";
	if ($effect->blur)
	{
		$blur=round($effect->blur*20/$effect->zoom,2);
		$ef_blur=" -blur 0x$blur";
	}
	if ($effect->sepia)		$ef_matrix.=" -color-matrix \" ".Matrix("0.393 0.769 0.189 0.349 0.686 0.168 0.272 0.534 0.131",$effect->sepia)." \"";
	if ($effect->bw)			$ef_matrix.=" -color-matrix \" ".Matrix("0.2126 0.7152 0.0722 0.2126 0.7152 0.0722 0.2126 0.7152 0.0722",$effect->bw)." \"";

	if ($effect->saturate!=1)		$ef_saturate=" -modulate 100,".round($effect->saturate*100,0);
	if ($effect->bright!=1)		$ef_bright=" -brightness-contrast ".($effect->bright*100-100);
	
	if ($effect->flipx&1)		$ef_flipflop.=" -flop";
	if ($effect->flipy&1)		$ef_flipflop.=" -flip";


	if ($ef_matrix||$ef_saturate||$ef_bright)
	{
		$channelRGB=" -channel RGB";
		$channelRGBA=" +channel";
	}
	else		$channelRGB=$channelRGBA="";
	/* rendering */
	if ($clipleft>=0)	$sig="+";
	else				$sig="";
	if ($cliptop>=0)	$sigt="+";
	else				$sigt="";

	if (($clipx2-$clipx)>=0 && ($clipy2-$clipy)>=0 && $clipleft<=$width && $cliptop<=$height)
	{
		$picname=addcslashes($object->data,' ');	// correction bug espaces nom
		$return=" \( $picname$rotation -crop $crop -resize $size$ef_blur$ef_flipflop$channelRGB$ef_matrix$ef_saturate$ef_bright$channelRGBA$ef_trans \) -geometry ".$sig.intval($clipleft).$sigt.intval($cliptop)." -composite";
		$_SESSION['nbobject']++;
		if ($effect->rotate)	$_SESSION['nbrot']++;
	}
	return $return;
}
/* utilitaires divers */
function Clip($delta,$ilen,$plen)
{
	return $delta*$plen/$ilen;
}
function Zoom($coord,$mid,$factor)
{
	return $mid-($mid-$coord)*$factor;
}
function Matrix($colors,$pc)
{
		$nope=array(1,0,0,0,1,0,0,0,1);
		$result=array();
		$color=explode(" ",$colors);
		for ($i=0;$i<9;$i++)
		{
			$result[$i]=$nope[$i]*(1-$pc)+$color[$i]*$pc;
		}
		return implode(" ",$result);
}

?>