// Déclaration de variables et structures
/* Valeurs par défaut */
var type_symbol=["movie","container","picture"];				// icones de la ligne objet
var type_defname=["Sans nom",_translate("Coffre"),"Picture"];
var PSuid = 1;				// index départ identifiant unique
var PSselected=0;			// objet sélectionné
var PSedEffect=0;			// fenêtre d'effet (effet concerné)
var PSmsgTimeout=null;		// si message en cours
// flag effect
const EFFECT_X=1, EFFECT_Y=2,EFFECT_WIDTH=4,EFFECT_HEIGHT=8,EFFECT_ZOOM=16,EFFECT_ROTATE=32;
const EFFECT_OPACITY=64,EFFECT_SHOW=128,EFFECT_BW=256,EFFECT_BLUR=512,EFFECT_FLIPX=1024,EFFECT_FLIPY=2048;
const EFFECT_SEPIA=4096,EFFECT_BRIGHT=8192,EFFECT_SATURATE=16384,EFFECT_RESET=32768,EFFECT_MBLUR=65536;
// move effects
const MOV_LINEAR=0;
// widget type
const WID_INFO=1, WID_CHECK=2,WID_CURSOR=3,WID_DCURSOR=4,WID_RCURSOR=5;
// Flags des changements
var PSChg=0;
// Valeurs de la timeline
var PSspaceSec=40;			// espace en pixels entre les secondes
var PStotalTime=20;			// durée du projet en secondes
var PSactualTime=0;			// position actuelle en secondes de la timeline
// anim
var PSanimTime=0;
var PSanimEvent=0;
var PSFrame=0;
// ping pong
var PSpingEvent;
// canvas
var 	canvas=null;
var ctx=null;
// objet copie effects
var PScopyEffect=function() {
	this.uid=false;						// uid de l'objet dont on doit copier les effets
	this.timestart=false;
	this.timestop=false;
}
var pscopy= new PScopyEffect(); 
// constructeur objets
var PSobject= function(type,data) {
	this.type=type;				// 0 : root, 1 container, 2 image
	this.rap=1;					// rapport hauteur /largeur
	this.data=data;				// rien, rien, image, future
	this.name=null;
	this.parent=0;
	this.firstchild=0;
	this.prev=null;
	this.next=null;
	this.uid=PSuid++;
	this.firsteffect=null;
	this.actualeffect=new PSeffect(0,0,true);
	this.effecttbl=new PStbl();		// table des effets à un instant t, PStbl
}
// structures du mouvement en cours
var PSinterval = function ()
{
		this.time1=false;
		this.val1=false;
		this.value=false;
}

var PStbl = function () {
	this.time=false;					// time défini précédemment
	this.flag=0;						// masque des valeurs initialisées
	this.x=new PSinterval();
	this.y=new PSinterval();
	this.width=new PSinterval();
	this.height=new PSinterval();
	this.zoom=new PSinterval();
	this.rotate=new PSinterval();
	this.opacity=new PSinterval();
	this.bw=new PSinterval();
	this.blur=new PSinterval();
	this.sepia=new PSinterval();
	this.bright=new PSinterval();
	this.saturate=new PSinterval();
	this.show=new PSinterval();
	this.reset=new PSinterval();
	this.flipx=new PSinterval();
	this.flipy=new PSinterval();
	this.mblur=new PSinterval();
}
// constructeur effets
var PSeffect=function(flag,parent,no_uid) {
	this.flag=flag;
	this.parent=parent;
	this.prev=null;
	this.next=null;
	if (!no_uid)	this.uid=PSuid++;
	else			this.uid=0;
	this.time=0;
	this.reset=0;	// à 1 on ne tient pas compte des valeurs antérieures pour le calcul
	this.x=0;
	this.y=0;
	this.width=false;
	this.height=false;
	this.zoom=1;
	this.rotate=0;
	this.opacity=1;
	this.show=0;
	this.flipx=0;
	this.flipy=0;
	this.bw=0;
	this.blur=0;
	this.sepia=0;
	this.bright=1;
	this.saturate=1;
	this.mblur=0;
}
// Undo
var	PSUndo=0;
var PSUndoEffect = function (flag, time, uid, reset, x, y, width, height, zoom, rotate, opacity, show, flipx, flipy, bw, blur, sepia, bright, saturate, mblur)
{
	this.flag=flag;
	this.time=time;
	this.uid=uid;			// uid éventuel de l'effet changé
	this.reset=reset;	// à 1 on ne tient pas compte des valeurs antérieures pour le calcul
	this.x=x;
	this.y=y;
	this.width=width;
	this.height=height;
	this.zoom=zoom;
	this.rotate=rotate;
	this.opacity=opacity;
	this.show=show;
	this.flipx=flipx;
	this.flipy=flipy;
	this.bw=bw;
	this.blur=blur;
	this.sepia=sepia;
	this.bright=bright;
	this.saturate=saturate;
	this.mblur=mblur;
}

// Racine
var PSobjChain = new Array();
var PSroot=0;		// n° du premier objet (1?)
// clipboard
var PSclipboard=new Array();
var PScorresp=new Array();
// Utilitaire PSobjChain
function _O(uid)
{
	return PSobjChain[uid];
}
/*----------- Création des objets et effets ------------*/
// création d'un objet
function ps_createObject(type,data,parent)
{
	PSChg++;
	$("#popuplock").hide();
	/* création objet */
	object=new PSobject(type,data);
	uid=object.uid;
	PSobjChain[uid]=object;
	/* création nom */
	if (data)	object.name=data.replace(/\\/g,'/').replace(/.*\//, '');
	else		object.name=type_defname[type];

	/* création effet 0% */ 
	effect=new PSeffect(0,uid);
	PSobjChain[effect.uid]=effect;
	object.firsteffect=effect.uid;
	/* chainage tableau */
	var last=0;
	if (type!=0)
	{
		object.parent=parent;
		if (!_O(parent).firstchild)	_O(parent).firstchild=uid;
		else
		{
				// <VAN MARQUE>
				last=ps_getLast(_O(parent).firstchild,PSselected);
				if (_O(last).next)	_O(_O(last).next).prev=uid;
				object.next=_O(last).next;
				object.prev=last;
				_O(last).next=uid;
		}
	}
	else			_O(0).rootuid=PSroot=uid;
	/* liste */
	ps_createObjLine(uid,last);
	/* affichage dans la preview */
	ps_addPreviewObject(uid);
	if (last)		$("#pobject"+last).after($("#pobject"+uid));		// on déplace l'objet
	/* sélection automatique du dernier objet */
	ps_selectObject(uid);
	ps_maskContainer(_O(uid).parent,true);
}
/* détruire un objet */
function ps_deleteObject(uid,all)
{
	PSChg++;
	if (all==undefined)	all=0;
	/* récursion */
	var object=_O(uid);
	if (object.type<2&&object.firstchild)			ps_deleteObject(object.firstchild,true);
	if (object.next&&all)							ps_deleteObject(object.next);
	/* on supprime les effets */
	ps_deleteAllEffects(object.firsteffect);
	/* on retire de la chaîne */
	if (!object.prev)	_O(object.parent).firstchild=object.next;
	else				_O(object.prev).next=object.next;
	if (object.next)	_O(object.next).prev=object.prev;
	/* on enlève du root */
	PSobjChain[uid]=0;
	/* On retire du visuel */
	$("#objline"+uid).remove();
	$("#pobject"+uid).remove();
	ps_selectObject(0);
}
function ps_deleteAllEffects(uid)
{
	var effect=_O(uid);
	if (effect.next)	ps_deleteAllEffects(effect.next);
	PSobjChain[uid]=0;
}
/* Affichage d'un objet dans la preview */
function ps_addPreviewObject(uid,old)
// old : l'objet a déjà été chargé, ne pas refaire oject.rap, etc..
{
	if (old==undefined)	old=false;
	var object=_O(uid);
	switch (object.type)
	{
		case 0:
			//var pdiv="#div-preview";
			var pdiv="#div-zoom";
			if (!old)
			{
				$(pdiv).append("<div id='pobject"+uid+"' style='width:"+prev_width+"px;height:"+prev_height+"px;'></div>");
				object.rap=prev_height/prev_width;
				var effect=_O(object.firsteffect);
				effect.flag=effect.flag|EFFECT_X|EFFECT_Y;
			}
			else		$(pdiv).append("<div id='pobject"+uid+"'></div>");
			break;
		case 1:
			if (!old)
			{
				$("#pobject"+object.parent).append("<div id='pobject"+uid+"' style='left:0px; top:0px; width:"+prev_width+"px;height:"+prev_height+"px;'></div>");
				object.rap=prev_height/prev_width;
				var effect=_O(object.firsteffect);
				effect.flag=effect.flag|EFFECT_X|EFFECT_Y;
			}
			else $("#pobject"+object.parent).append("<div id='pobject"+uid+"' ></div>");
			break;
		case 2:
				$("#pobject"+object.parent).append("<img id='pobject"+uid+"' src='"+object.data+"'>");
				if (!old)
				{
					$("#pobject"+uid).one("load",function () {
					var h=document.getElementById("pobject"+uid).naturalHeight;
					var w=document.getElementById("pobject"+uid).naturalWidth;
					if (!w)	w=prev_width;
					if (!h)	h=prev_height;
					object.rap=h/w;
					/* calcul de la largeur */
					var effect=_O(object.firsteffect);
					if (w>prev_width)	w=prev_width;
					effect.flag=effect.flag|EFFECT_WIDTH|EFFECT_X|EFFECT_Y;
					effect.width=w/prev_width;
					effect.height=false;
					ps_modifyPreviewObject(uid,effect);
					});
				}
			break;
		default:
			if (!old)	object.rap=prev_height/prev_width;
			break;
	}
}
// move
function ps_modifyPreviewObject(uid,effect,flag)
{
	if (flag==undefined)	flag=false;
	var type=_O(effect.parent).type;
	if (flag===false)				flag=effect.flag;
	if ((flag&EFFECT_SHOW)&&effect.show)
	{
		$("#pobject"+uid).hide();
		return;
	}
	// taille et position
	if (flag&EFFECT_X)			$("#pobject"+uid).css("left",(effect.x*prev_width));
	if (flag&EFFECT_Y)			$("#pobject"+uid).css("top",(effect.y*prev_height));
	// tailles
	if (type<2 && effect.width===false)
	{
		$("#pobject"+uid).css("overflow","visible");
		$("#pobject"+uid).width(prev_width+"px");
		$("#pobject"+uid).height(prev_height+"px");
		$("#pobject"+uid).css("transform-origin","left top");
	}
	else
	{
		$("#pobject"+uid).css("overflow","hidden");
		$("#pobject"+uid).css("transform-origin","50% 50%");
		if (flag&EFFECT_WIDTH)					$("#pobject"+uid).width(effect.width*prev_width);
		if ((flag&EFFECT_HEIGHT)&&effect.height!==false)
		{
			if (!flag&EFFECT_WIDTH)					$("#pobject"+uid).width(effect.width*prev_width);
			$("#pobject"+uid).height(effect.height*prev_height);
		}
		else
		{
			if (effect.height===false)	$("#pobject"+uid).height(prev_width*effect.width*_O(effect.parent).rap);	
			else							$("#pobject"+uid).height(prev_height*effect.height);	
		}
	}
	// effets
	if (flag&EFFECT_OPACITY)	$("#pobject"+uid).css("opacity",effect.opacity);
	if (flag&(EFFECT_FLIPX|EFFECT_FLIPY|EFFECT_ROTATE|EFFECT_ZOOM))
	{
		fpx=fpy=1;
		rot=effect.rotate*360;
		scalex=scaley=effect.zoom;
		if (effect.flipx)	scalex*=-1;
		if (effect.flipy)	scaley*=-1;
		$("#pobject"+uid).css("transform","scale("+scalex+","+scaley+") rotate("+rot+"deg)");
	}

	// filtre
	filter="";
	if (((effect.flag|flag)&EFFECT_BLUR)&&effect.blur)				filter+=" blur("+(effect.blur*5)+"px)";
	if (((effect.flag|flag)&EFFECT_BW)&&effect.bw)					filter+=" grayscale("+(effect.bw)+")";
	if (((effect.flag|flag)&EFFECT_SEPIA)&&effect.sepia)				filter+=" sepia("+(effect.sepia)+")";
	if (((effect.flag|flag)&EFFECT_SATURATE)&&effect.saturate!=1)	filter+=" saturate("+(effect.saturate)+")";
	if (((effect.flag|flag)&EFFECT_BRIGHT)&&effect.bright!=1)		filter+=" brightness("+(effect.bright)+")";
	if (filter!="")							$("#pobject"+uid).css("filter",filter);
	else									$("#pobject"+uid).css("filter","none");
	if ((flag&EFFECT_SHOW)&&!effect.show)
	{
		$("#pobject"+uid).show();
	}
}
/*----------- utilitaires chainage ------------*/
// rechercher le dernier d'une chaîne
function ps_getLast(actual,brother)
{
		while (_O(actual).next && actual!=brother)	actual=_O(actual).next;
		return actual;
}
/*------------ Time line -------------------*/
// Valeurs de la timeline
// PSspaceSec=40;			// espace en pixels entre les secondes
// PStotalTime=30;			// durée du projet en secondes
// PSactualTime=0;			// position actuelle en secondes de la timeline
function ps_drawTimeLine()
{
	txt="";
	if (PSspaceSec==20)
	{
		var sec="";
		var ftsize=11;
	}
	else
	{
		var sec="s";
		var ftsize=14.4;
	}
	for (i=1;i<=PStotalTime;i++)
	{
		txt+="<div class='span-second' style='font-size:"+ftsize+"px;left:"+((i-1)*PSspaceSec)+"px;width:"+PSspaceSec+"px;'>"+i+sec+"</div>";
	}
	$("#div-timeline-ruban").width(PSspaceSec*PStotalTime);
	$("#div-timeline-effects").width(PSspaceSec*PStotalTime);
	$("#div-timeline-ruban").html(txt);
	ps_posiTimeLine();
}
// boutons de positionnement
function ps_tl_setmin()
{
	PSactualTime=0;
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
}
function ps_tl_setmax()
{
	PSactualTime=PStotalTime;
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
}
function ps_tl_setprev()
{
	// trouver la bonne marque
	if (!PSselected ||!PSactualTime)	return;
	uid=_O(PSselected).firsteffect;
	lastgood=uid;
	while (uid && _O(uid).time<PSactualTime)
	{
		lastgood=uid;
		uid=_O(uid).next;
	}
	PSactualTime=_O(lastgood).time;
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
}
function ps_tl_setnext()
{
	// trouver la bonne marque
	if (!PSselected || PSactualTime==PStotalTime)	return;
	uid=_O(PSselected).firsteffect;
	while (uid && _O(uid).time<=PSactualTime)
	{
		uid=_O(uid).next;
	}
	if (!uid)	PSactualTime=PStotalTime;
	else		PSactualTime=_O(uid).time;
	ps_posiTimeLine();
	ps_getEffects(PSroot,0);
}
// position de la div par rapport à la valeur PSactualTime
function ps_posiTimeLine()
{
	ps_closeEffect();
	zero=$("#div-timelineleft").width()/2;
	$("#div-timeline-ruban").css("left",zero-(PSactualTime*PSspaceSec));
	$("#div-timeline-effects").css("left",zero-(PSactualTime*PSspaceSec));
	$("#actual-time").html(parseFloat(PSactualTime).toFixed(1));
}

/*------------ file request -----------------*/
// Choix d'un fichier
function ps_addFileObject(event,type,parent)
{
	// <VAN MARQUE>
	event.stopPropagation();
	ps_closeEffect();
	//ps_objless(parent);
	ps_filerequest(_translate("Ajouter une image"),parent,type,true);
	return false;
}
function ps_cancel()
{
	$("#popuplock").hide();
	$("#popuplock").html("");
}
// renvoyer la preview xs d'une image
function ps_imgpreview(img)
{
	if (!ps_usexs)	return img; 
	var names=img.split("/");
	var last=names.length-1;
	names[last]="xs-"+names[last];
	return names.join("/");
}
// changement d'une image
function	ps_chgFileObject(uid)
{
	var object=_O(uid);
	ps_filerequest(_translate("Changement de l'image")+" ("+object.name+")",uid,2,false);
}

/*------------ Sélection des objets -------------*/ 
var ps_tmpshow=0;
// Sélection d'un objet
function	ps_selectObject(uid)
{
	if (PSselected==uid)		return;
	ps_closeEffect();
	// désélection de l'ancien
	if (PSselected)
	{
		$("#objline"+PSselected).css("border-color","");
		$("#objline"+PSselected).css("background-color","");
		$("#div-timeline-effects").empty();
	}
	PSselected=uid;
	if (uid==0)		return;						// effacement sélection uniquement
	// sélection du nouveau
	$("#objline"+uid).css("border-color","#8866FF");
	$("#objline"+uid).css("background-color","#3322ff");
	// marque ?
	ps_displayMark();
	// création ligne d'effets
	effect=PSobjChain[uid].firsteffect;
	lastleft=-10;
	etop=0;
	while (effect)
	{
		objeffect=PSobjChain[effect];
		left=objeffect.time*PSspaceSec;
		if ((left-lastleft)<7)
		{
			left=lastleft+7;
			etop+=3;
		}
		else		etop=0;
		lastleft=left;
		//if (objeffect.time)	events=" ontouchstart=dd_touchStart(event,"+effect+") ondragstart='PS_drag(event,"+effect+");' draggable='true'";
		if (objeffect.time)	events=" ontouchstart='psm_Start(event,"+effect+");' onmousedown='psm_Start(event,"+effect+");'"; 
		else					events=" ontouchstart='ps_clickEffect("+effect+");' onmousedown='ps_clickEffect("+effect+");'";
		//events+=" onclick='ps_clickEffect("+effect+");'";
		$("#div-timeline-effects").append("<div"+events+" id='div-effect"+effect+"' class='closed-effect' style='left:"+left+"px;top:"+etop+"px;'></div>");
		effect=objeffect.next;
	}
	// apparition temporaire
	if (ps_tmpshow)
	{
		clearTimeout(ps_tmpshow);
		ps_tmpshow=0;
	}
	eff_chgEffect(uid);
	ps_tmpshow=setTimeout(ps_noshow,1000);
}
function ps_noshow()
{
	eff_showEffect(false);
	ps_tmpshow=0;
}
/* ------ Cadres more ------ */
// mouse leave
function	ps_objmore(num)
{
	if ($("#objmore"+num).css('display')=="none")	$("#objmore"+num).css('display', 'inline');
	else											ps_objless(num);	
}
function	ps_objless(num)
{
	$("#objmore"+num).hide();
}
// more click
function ps_addObject(type,parent)
{
	//<VAN MARQUE>
	//ps_objless(parent);
	ps_createObject(type,0,parent);
}
// --- Resize buttons !
function ps_resizebuttons()
{
	var height=$(window).height();
	var RightH=height-$("#div-button").outerHeight(true)-4;
	$("#div-neweffect").height(RightH-TopEffet-30);
}
// ------------------------resize
var RightW=0;
var RightH=0;
//var RightTop=0;
var RightLeft=0;
function	ps_resize()
{
		if ("ontouchstart" in window)		$("#zoom-table").hide();
		else								$("#zoom-table").show();
		// calcul taille preview
		var zero=_O(0);
		if (zero==undefined)		return;
		var width=$(window).width();
		var height=$(window).height();
		var h=height;
		var w=width;
		// largeur de la preview
		var mw=w-420;						// max w
		var mh=h-130;						// max h
		var h=(w*zero.factory)/zero.factorx;
		if (h>mh)
		{
			h=mh;
			w=(h*zero.factorx)/zero.factory;
		}
		if (w>mw)
		{
			w=mw;
			h=(w*zero.factory)/zero.factorx;
		}
		prev_height=h;
		prev_width=w;
		// preview
		$("#div-preview").width(w);
		$("#div-preview").height(h);
		$("#div-zoom").width(prev_width);
		$("#div-zoom").height(prev_height);
		$("#div-zoom").css("transform-origin","50% 50%");
		psm_center();
		// div fps
		$("#div-fps").css("left",(w-100)+"px");
		// si trop étroit, on migre la longueur de la scène
		if (w<500)
		{
			$("#sysmsg").before($("#tl_lngcommand"));
			$("#tl_lngcommand").css({height:'40px',verticalAlign:'middle'});
			if (w<340)
			{
				$("#sysmsg").before($("#tl_copycommand"));
				$("#tl_copycommand").css({height:'40px',verticalAlign:'middle'});
			}
		}
		else
		{
			$("#div-timeline-buttons").append($("#tl_copycommand"));
			$("#tl_copycommand").css("height","");
			$("#div-timeline-buttons").append($("#tl_lngcommand"));
			$("#tl_lngcommand").css("height","");
		}
		// div buttons
		var rightw=width-w-20;				// marge preview 2*10
		$("#div-button").width(rightw-12);  // border 2*1 / padding 2*5
		$("#div-button").css("left",w+20);

		// div right size
		RightW=rightw-4;
		RightH=height-$("#div-button").outerHeight(true)-4;
		//RightTop=$("#div-button").height();
		RightLeft=w+20;
		$("#div-right").width(RightW);	// border 2*1 / padding 2*1
		$("#div-right").css("left",RightLeft);
		$("#div-right").height(RightH);
	
		/* barre des effets */
		$("#div-neweffect").width(RightW);	// border 2*1 / padding 2*1
		$("#div-neweffect").css("left",RightLeft);
		$("#ef-bar").width(RightW);	// border 2*1 / padding 2*1
		$("#ef-bar").css("left",RightLeft);

		// valeur par défaut du positionnement
		TopEffet=70;

		// div buttons
		$("#div-timeline-buttons").css({top:(h+15)+"px",width:(w+20)+"px"});

		// div timeline
		$("#div-timelineleft").css({top:(h+15+40)+"px",width:(w+20)+"px"});

		// timeline
		ps_posiTimeLine();
		if ($("#anim-div").length)
		{
			// pos et taille de la fenêtre settings
			var left=$('#div-preview').width()+20;
			var height=$('#div-preview').height()+20;
			$("#anim-div").css({"left":left,"height":height});
			var dheight=$(window).height()-height-2;
			$("#debug-div").css({"top":height,"height":dheight});
		}
		else		ps_getEffects(PSroot,0);
}
function ps_butresize()
{
		var height=$(window).height();
		RightH=height-$("#div-button").outerHeight(true)-4;
		$("#div-right").height(RightH);
}
// Changer timespace
function ps_tl_loupe() {
	// 30 40 50 60
	PSspaceSec+=20;
	if (PSspaceSec>80)	PSspaceSec=20;
	$("#si-loupe").css("background-image","url('data/newicons/si_loupe"+PSspaceSec+".svg')");
	ps_drawTimeLine();
	var uid=PSselected;
	ps_selectObject(0);
	ps_selectObject(uid);
	ps_getWaveForm();
}
// quitter
function ps_exit()
{
	if (!PSChg || PSdemo)
	{
		ps_pingOff();
		return;
	}
	var html="<div id='drawerpopup' style='background-color:rgba(200,200,200,.8)'><h1 style='color:red'>"+_translate("Si vous quittez vos changements seront perdus !")+"</h1>";
	html+="<div style='margin-left:10px;text-align:center;float:left;' ><span onclick='ps_cancel()' class='button'>"+_translate("Annuler")+"</span></div>";
	html+="<div style='margin-right:10px;text-align:center;float:right;' ><span onclick='ps_exit2()' class='button'>"+_translate("Quitter")+"</span></div>";
	html+="</div>";
	$("#popuplock").html(html);
	$("#popuplock").css("background-color","rgba(0,0,0,.5)");
	$("#popuplock").show();
}
function ps_exit2()
{
	ps_cancel();
	ps_pingOff();
}
/*----------- Messages système -----------*/
function ps_Msg(txt,error)
{
	if (error)	txt="<span style='color:red;'>"+txt+"</span>";
	else			txt="<span style='color:black'>"+txt+"</span>";
	if (PSmsgTimeout)
	{
		clearTimeout(PSmsgTimeout);
		PSmsgTimeout=null;
	}
	$("#sysmsg").html(txt);
	PSmsgTimeout=setTimeout(function() {
		PSmsgTimeout=null;
		$("#sysmsg").html("");
	}, 10000);
}
/*--- Ping Pong ----*/
function ps_pingEvent()
{
	if (PSdemo)	return;
	var project="projects/"+PSproject+"/"+PSscene+"/anim.lock";
	$.post("ping.php",{ping: "ping",project:project}, function (data) {
		// afficher le retour
		$("#server").css("background-image","url('data/adm/ctcok.svg')");
		setTimeout(function (){
			$("#server").css("background-image","url('data/adm/ctcoff.svg')");
		},1000);
		//console.log(data);
	});
}
function ps_pingOff()
{
	if (PSdemo)		$( location ).attr("href", "index.php?lng="+ADMlng);
	clearInterval(PSpingEvent);
	PSpingEvent=null;
	var project="projects/"+PSproject+"/"+PSscene+"/anim.lock";
	$.post("ping.php",{ping: "paf",project:project}, function (data) {
		// quitter le programme
		$( location ).attr("href", "project.php");
		//console.log(data);
	});
}
/*----------------- Première initialisation ------------------*/
/* mise en place root */
function ps_ready()
{
	$("#brepeffect").hide();
	$("#bremeffect").hide();
	// Chargement projet
	ps_loadProject();
	ps_resize();
	// mise en place ping
	if (!PSdemo)	PSpingEvent=setInterval(ps_pingEvent,60000);
}
/*----------------- Préparation de la page ------------------*/
/* Mise en place des scripts automatiques */
$(document).ready(ps_ready);
$(window).resize(ps_resize);
if (!PSdemo)
{
	$(window).on('beforeunload',  function (data) {
	clearInterval(PSpingEvent);
	PSpingEvent=null;
	var project="projects/"+PSproject+"/"+PSscene+"/anim.lock";
	$.post("ping.php",{ping: "paf",project:project});	// suppression du lock
	});
}
