<?php
	// arguments
	if (!isset($argv[1]) || !$argv[1])		exit("bad args");
	$scriptname=$argv[1];

	// config
	require ("include/cfg.php");

	// arguments supplémentaires
	$tsk=file_get_contents("tasks/$scriptname.tsk");
	if (!$tsk)		exit("fichier introuvable");						// fichier introuvable

	// trois lignes de valeurs
	// [0] mode (<init> <waiting>||<ready>  <running> <canceled(!)>|| <error>||<done>)
	$tsk=explode("\n",$tsk);
	if (count($tsk)!=3)	exit(0);
	$mode=$tsk[0];
	$info=$tsk[1];
	$dir=$tsk[2];
	if ($mode!="<waiting>")	exit(0);
	messagelog("Démarrage : $scriptname répertoire : $dir");
	// processus lockés ?
	while (ps_getlock($scriptname))		sleep(10);
	// running
	$_SESSION['starttime']=time();
	ps_setmode($scriptname,"<running>",$dir);
	// on charge le fichier dat
	$data=file_get_contents("tasks/$scriptname.dat");
	if (!$data)	ps_setmode($scriptname,"<error>",$dir);
	$data=json_decode($data);
	// on efface les données
	ps_delete($scriptname,$dir);
	// on boucle
	$idx=1;
	$length=count($data)-1;

	$error=false;
	while (!$error && ps_setmode($scriptname,"<running>",$dir,"$idx/$length") && $idx<=$length)
	{
		$error=ps_exec($data[$idx-1],$dir);
		$idx++;
	}
	if (!$error) $error=ps_exec($data[$idx-1],$dir);
	if ($error)	ps_setmode($scriptname,"<error>",$dir,$idx--);
	messagelog("$scriptname terminée avec succès");
	$info=getrendertime();
	messagelog("Durée du rendu : $info");
	ps_setmode($scriptname,"<done>",$dir,$info);
	exit(0);
/* msglog */
function messagelog($msg)
{
	file_put_contents("log/console.log",date(DATE_RFC2822)." $msg".PS_ENDOFLINE,FILE_APPEND);
}
/* changement de mode */
function ps_setmode($id,$mode,$dir,$info=false)
{
	// info ?
	if (!$info)	$info="--/--";
	// regarder si mode a changé
	$new=file_get_contents("tasks/$id.tsk");
	if ($new===false)
	{
		/* fichier supprimé, on sort sur la pointe des pieds */
		if (!ps_getlock($id) && file_exists("tasks/pst.lock"))		ps_rmfiles("tasks/pst.lock");
		messagelog("Tâche $id supprimée");
		exit("Tâche supprimée");
	}
	$new=explode("\n",$new);
	if ($new[0]=="<stop>")	$mode="<canceled>";
	file_put_contents("tasks/$id.tsk","$mode\n$info\n$dir");
	if ($mode=="<canceled>"||$mode=="<error>"||$mode=="<done>")
	{
		if ($mode=="<canceled>")	messagelog("$id annulée");
		ps_delete($id,$dir);
		if (!ps_getlock($id) && file_exists("tasks/pst.lock"))		ps_rmfiles("tasks/pst.lock");
		exit(0);
	}
	ps_getlock($id);
	return $mode;
}
/* attendre processus bloqués */
function ps_getlock($scriptname)
{
	if (file_exists("tasks/pst.lock"))
	{
		$lock=file_get_contents("tasks/pst.lock");
		$lock=explode("\n",$lock);
		if ($lock[0]!=$scriptname&&($lock[1]+120)>time())	return true;
	}
	file_put_contents("tasks/pst.lock",$scriptname."\n".time());
	return false;
}
/* suppression des fichiers de travail */
function ps_delete($id,$dir=false)
{
	ps_rmfiles("tasks/$id.dat");
	if ($dir)	ps_rmfiles("$dir/anim/frame*.jpg");
}
/* Suppression des fichiers */
function ps_rmfiles($files)
{
	$liste=glob($files);
	$nb=count($liste);
	if (!$nb)		return;

	$idx=0;
	$errors=0;
	while (isset($liste[$idx]))
	{
		if (unlink($liste[$idx])===false)		$errors++;
		$idx++;
	}
	if ($errors)	messagelog("$errors erreur(s) lors de la suppression des fichiers ($dir)");
}
/* commande */
/* Exécution des commandes exec */
function ps_exec($cmd,$dir)
{
	putenv('LANG=fr_FR.UTF-8');
	exec($cmd,$out,$status);
	if ($status)
	{
		messagelog("Commande : ".$cmd);
		foreach ($out as $line) messagelog("Erreur : $line");
		return true;
	}
	return false;
}
/* calcul temps rendu */
function getrendertime()
{
	$sec=time()-$_SESSION['starttime'];
	$m=floor($sec/60);
	$h=floor($m/60);
	return $h.":".sprintf("%02d",$m%60).":".sprintf("%02d",$sec%60);
}
?>
